if Dominos then
--[[ Globals ]]--
local AddonName = ...
local Addon = LibStub('AceAddon-3.0'):GetAddon("Dominos")
local KeyBound = LibStub('LibKeyBound-1.0')

--[[ Bar ]]--
local QuestBar = Addon:CreateClass('Frame', Addon.Frame)
QuestBar.master = Addon
_G[...] = QuestBar

do
	function QuestBar:New()
		local frame = QuestBar.proto.New(self, 'quest')
		frame.scroll = CreateFrame("ScrollFrame", frame:GetName().."ScrollFrame", frame, MinimalHybridScrollFrameTemplate)
		frame.scroll:ClearAllPoints()
		frame.scroll:SetPoint('TopLeft', 0, 0)
		frame.scroll:SetPoint('BottomRight', 0, 0)
		frame.scroll.maxRange = 1
		frame.scroll:SetScript("OnMouseWheel", function(self, step)
			local range = ceil(ObjectiveTrackerBlocksFrame.contentsHeight - self:GetHeight() )
			if self.maxRange ~= range then
				self.maxRange = range 
			end 
			local shift = (self:GetVerticalScroll() + (frame.sets.scrollStep * (step * -1)))
			if shift <= -1 then
				shift = -1
			elseif shift >= range then
				shift = self.maxRange 
			end
			self.shift = shift
			self:SetVerticalScroll(shift)
			self:SetHorizontalScroll(-30)
		end)
		frame.scroll:SetVerticalScroll(-1)
		local watch = ObjectiveTrackerFrame
		watch.HeaderMenu.MinimizeButton:ClearAllPoints()
		watch.HeaderMenu.MinimizeButton:SetPoint("TopRight", frame)
		watch:SetParent(frame)
		watch:SetMovable(true)
		watch:SetUserPlaced(true)
		watch:ClearAllPoints()
		frame.scroll:SetScrollChild(watch)
		watch:ClearAllPoints()
		watch:SetPoint('TopLeft', 30, 0)
		watch:SetHeight(2000)
		frame.watch = watch
		
		watch:HookScript("OnEvent", function()
			local range = ceil(ObjectiveTrackerBlocksFrame.contentsHeight - frame.scroll:GetHeight() )
			if frame.scroll.maxRange ~= range then
				frame.scroll.maxRange = range 
			end
			frame.scroll.shift = frame.scroll.shift or 0
			if frame.scroll.shift > range then
				frame.scroll.shift = frame.scroll.maxRange
				frame.scroll:SetVerticalScroll(frame.scroll.shift)
			end
		end)
		
		return frame
	end

	function QuestBar:Layout()
		local w, h = ObjectiveTrackerFrame:GetSize()
		--self.sets.width*1.5
		self:SetSize(175*1.5, self.sets.height*1.5)
		if self.watch.lineWidth ~= self:GetWidth() - 30 then
			self.watch.lineWidth = self:GetWidth() - 30
			
		end
		self.sets.scrollStep = self.sets.scrollStep or 50
	end

	function QuestBar:GetDefaults()
		return {
			point = 'TopRight',
			spacing = 0,
			x = 0,
			y = -200,
			width = 195,
			height = 420,
			scrollStep = 50
		}
	end
end
elseif Bartender4 then

local Bartender4 = Bartender4
local L = LibStub("AceLocale-3.0"):GetLocale("Bartender4")

-- fetch upvalues
local Bar = Bartender4.Bar.prototype

local table_insert, setmetatable = table.insert, setmetatable

-- GLOBALS: ObjectiveTrackerFrame

local defaults = { profile = Bartender4:Merge({
	enabled = true,
}, Bartender4.Bar.defaults) }

-- register module
local ObjectiveBarMod = Bartender4:NewModule("ObjectiveBar", "AceHook-3.0")

-- create prototype information
local ObjectiveBar = setmetatable({}, {__index = Bar})

function ObjectiveBarMod:OnInitialize()
	self.db = Bartender4.db:RegisterNamespace("ObjectiveBar", defaults)
	self:SetEnabledState(self.db.profile.enabled)
end

function ObjectiveBarMod:OnEnable()
	if not self.bar then
		--self:SetScript("OnEnter", print)
	
		self.bar = setmetatable(Bartender4.Bar:Create("ObjectiveBar", self.db.profile, L["Objective Bar"]), {__index = ObjectiveBar})
		self.bar.overlay:RegisterForClicks("AnyUp")
		self.bar.overlay:SetScript("OnClick", function(self, btn)
			print(btn)
			if btn == "RightButton" then
			end		
		end)

		self.bar.content = ObjectiveTrackerFrame

		self.bar.content:SetParent(self.bar)
		self.bar.content:SetMovable(true)
		self.bar.content:SetUserPlaced(true)

		self.bar.content:SetFrameLevel(self.bar:GetFrameLevel() + 1)
	end
	self.bar:Enable()
	self:ToggleOptions()
	self:ApplyConfig()
end

function ObjectiveBarMod:ApplyConfig()
	self.bar:ApplyConfig(self.db.profile)
end


function ObjectiveBar:ApplyConfig(config)
	Bar.ApplyConfig(self, config)
	if not self.config.position.x then
		self:ClearSetPoint("TopRight", -370, -185)
		self:SavePosition()
	end
	self:PerformLayout()
end

ObjectiveBar.width = 183
ObjectiveBar.height = 420
ObjectiveBar.offsetX = 0
function ObjectiveBar:PerformLayout()
	self:SetSize((self.width*1.5), (self.height*1.5))
	local bar = self.content
	bar:ClearAllPoints()
	bar:SetPoint("TOPLEFT", self, "TOPLEFT", 33, -3)

end

ObjectiveBar.ClickThroughSupport = true
function ObjectiveBar:ControlClickThrough()
	self.content:EnableMouse(not self.config.clickthrough)
end
end