--[[
	Copyright (c) 2009-2015, Hendrik "Nevcairiel" Leppkes < h.leppkes at gmail dot com >
	All rights reserved.
]]
local _, Bartender4 = ...
local L = LibStub("AceLocale-3.0"):GetLocale("Bartender4")

-- fetch upvalues
local Bar = Bartender4.Bar.prototype

local table_insert, setmetatable = table.insert, setmetatable

-- GLOBALS: ObjectiveTrackerFrame

local defaults = { profile = Bartender4:Merge({
	enabled = true,
}, Bartender4.Bar.defaults) }

-- register module
local ObjectiveBarMod = Bartender4:NewModule("ObjectiveBar", "AceHook-3.0")

-- create prototype information
local ObjectiveBar = setmetatable({}, {__index = Bar})

function ObjectiveBarMod:OnInitialize()
	self.db = Bartender4.db:RegisterNamespace("ObjectiveBar", defaults)
	self:SetEnabledState(self.db.profile.enabled)
end
local LDBIcon = LibStub("LibDBIcon-1.0", true)

function ObjectiveBarMod:OnEnable()
	if not self.bar then
		--self:SetScript("OnEnter", print)
	
		self.bar = setmetatable(Bartender4.Bar:Create("ObjectiveBar", self.db.profile, L["Objective Bar"]), {__index = ObjectiveBar})
		self.bar.overlay:RegisterForClicks("AnyUp")
		self.bar.overlay:SetScript("OnClick", function(self, btn)
			print(btn)
			if btn == "RightButton" then
				LDBIcon["Show"](LDBIcon, "Bartender4")
			end		
		end)

		self.bar.content = ObjectiveTrackerFrame

		self.bar.content:SetParent(self.bar)
		self.bar.content:SetMovable(true)
		self.bar.content:SetUserPlaced(true)

		self.bar.content:SetFrameLevel(self.bar:GetFrameLevel() + 1)
	end
	self.bar:Enable()
	self:ToggleOptions()
	self:ApplyConfig()
end

function ObjectiveBarMod:ApplyConfig()
	self.bar:ApplyConfig(self.db.profile)
end

function ObjectiveBar:ApplyConfig(config)
	Bar.ApplyConfig(self, config)
	if not self.config.position.x then
		self:ClearSetPoint("TopRight", -370, -185)
		self:SavePosition()
	end
	self:PerformLayout()
end

ObjectiveBar.width = 183
ObjectiveBar.height = 420
ObjectiveBar.offsetX = 0
function ObjectiveBar:PerformLayout()
	self:SetSize((self.width*1.5), (self.height*1.5))
	local bar = self.content
	bar:ClearAllPoints()
	bar:SetPoint("TOPLEFT", self, "TOPLEFT", 33, -3)

end

ObjectiveBar.ClickThroughSupport = true
function ObjectiveBar:ControlClickThrough()
	self.content:EnableMouse(not self.config.clickthrough)
end